Unit Buttons;

Interface
Type Button = Object
                x,y,x1,y1 : Integer;
                State     : Boolean;
                Mes       : String;
                IsEvents  : Boolean;
                Constructor Init(xx,yy,xx1,yy1:Word; mes1 : String);
                Procedure   ReDraw;virtual;
                Procedure   Event;virtual;
                Function    IsEvent:Boolean;
                Procedure   Press;virtual;
                Procedure   DownShow;
                Procedure   UpShow;
                Destructor  Done;
              End;

Implementation
uses Mouse,Graph,APP,NewGraph;

Constructor Button.Init(xx,yy,xx1,yy1:Word; mes1 : String);
Begin
  x:=xx;
  y:=yy;
  x1:=xx1;
  y1:=yy1;
  mes:=mes1;
  State := False;
  ReDraw;
End;

Destructor Button.Done;
Begin
End;

Procedure Button.Press;
Begin
End;

Procedure Button.DownShow;
Var midx,midy : Integer;
Begin
  DownFrame(App_x+X,App_y+y,App_x+X1,App_y+Y1);
  mouseoff;
  midy:=App_x+(y1-y) div 2-4 + y;
  midx:=App_x+(x1-x) div 2-length(mes) * 4 + x;
  SetColor(15);
  outtextxy(midx+2,midy+2,mes);
  mouseon;
End;

Procedure Button.UpShow;
Var midx,midy : Integer;
Begin
  UpFrame(App_x+X,App_y+y,App_x+X1,App_y+Y1);
  mouseoff;
  midy:=App_y+(y1-y) div 2-4 + y;
  midx:=App_x+(x1-x) div 2-length(mes) * 4 + x;
  outtextxy(midx+1,midy+1,mes);
  mouseon;
End;

Procedure Button.ReDraw;
Begin
  if State Then DownShow Else UpShow
End;

Procedure   Button.Event;
Begin
  if (MouseX > App_X+x) and (MouseX < App_X+x1) and
     (MouseY > App_Y+y) and (MouseY < App_Y+Y1) Then
  Begin
    DownShow;
    Press;
    Pause;
    UpShow;
    IsEvents := True;
  End Else IsEvents := False;
End;
Function Button.IsEvent : Boolean;
Begin
  Event;
  IsEvent := IsEvents;
End;
End.